#ifndef  _d3bb9300_aa87_4418_9dbd_e5cd0460a674
#define  _d3bb9300_aa87_4418_9dbd_e5cd0460a674

#include "Miscellanea.h"
#include <cstdint>
#include <cstdio>
#include <stdexcept>
#include <string>
#include <memory>


namespace my
{
    class CharDigester
    {
    public:
        typedef std::unique_ptr<CharDigester> Ptr;

        static
        Ptr Create(char const* encoding);

        virtual ~CharDigester(){}

        virtual
        void operator()(unsigned char const* buf, std::size_t n)
            = 0;

        virtual
        std::uint_fast32_t const (&GetCounter() const)[DIM_CHARS]
            = 0;

        virtual
        std::uint_fast32_t GetNumErrors() const
            = 0;

        virtual
        void ResetState()
            = 0;

        void operator()(std::FILE* fin);
        void operator()(char const* szFilePath);
    };


    inline
    void CharDigester::operator()(std::FILE* fin)
    {
        unsigned char buf[1024];
        std::size_t   cb;

        while(cb = std::fread(buf, sizeof(buf[0]), lengthof(buf), fin), cb > 0){
            (*this)(buf, cb);
        }
    }


    inline
    void CharDigester::operator()(char const* szFilePath)
    {
        std::FILE* fin = std::fopen(szFilePath, "rb");
        if(! fin){
            throw std::runtime_error
            (   std::string("File inaccessible: ")
                + szFilePath
            );
        }

        (*this)(fin);

        std::fclose(fin);
    }

} // namespace my
#endif //_d3bb9300_aa87_4418_9dbd_e5cd0460a674
