#ifndef  _3d90f6d1_7dad_4884_86bc_36b034dd21b6
#define  _3d90f6d1_7dad_4884_86bc_36b034dd21b6

#include "Miscellanea.h"
#include <algorithm>
#include <cstdint>

namespace my
{
    // Base class of multi-byte char counter.
    // It defines common functionality
    // but does not declare virtual interfaces,
    // for fear of inefficiency.
    // Instead, this class is used as a template parameter
    // the argument of which is one of its subclasses.
    class Counter
    {
    public:
        Counter()
        {
            std::fill_n(counter_, lengthof(counter_), 0);
            errors_ = 0;
        }

        std::uint_fast32_t const (&GetCounter() const)[DIM_CHARS]
        {
            return counter_;
        }

        std::uint_fast32_t GetNumErrors() const
        {
            return errors_;
        }

    protected:
        void CountUp(unsigned char c){ ++ counter_[c]; }
        void CountUpErrors(){ ++ errors_; }
        void CountUpErrors(std::uint_fast32_t n){ errors_ += n; }

    private:
        std::uint_fast32_t counter_[DIM_CHARS];
        std::uint_fast32_t errors_;
    };


} // namespace my

#endif //_3d90f6d1_7dad_4884_86bc_36b034dd21b6
