#ifndef  _23329405_8a1c_482b_be8e_b99fd3402465
#define  _23329405_8a1c_482b_be8e_b99fd3402465

#include "Counter.h"
#include "Miscellanea.h"
#include <algorithm>

namespace my
{
    class CounterUTF8 : public Counter
    {
    public:
        CounterUTF8()
        {
            this->ResetState();
        }

        void ResetState()
        {
            position_ = 0;
        }

        void operator()(unsigned char c)
        {
            if(position_ == 0){
                if(this->Is1stChar(c)){
                    chars_[0] = c;
                    position_ = 1;
                }
                else{
                    this->OnError(c);
                }
                return;
            }

            if(this->Is2ndChar(c)){
                chars_[position_++] = c;
            }
            else{
                this->OnError(c);
                position_ = 0;
                return;
            }

            if(position_ == length_){
                for(unsigned char i = 0; i < length_; ++i){
                    Counter::CountUp(chars_[i]);
                }
                position_ = 0;
            }
        }

    private:
        bool Is1stChar(unsigned char c){
            if(!(c & 0x80)) return false;

            if((c & 0xe0) == 0xc0){
                length_ = 2;
                return true;
            }

            if((c & 0xf0) == 0xe0){
                length_ = 3;
                return true;
            }

            if((c & 0xf8) == 0xf0){
                length_ = 4;
                return true;
            }

            if((c & 0xfc) == 0xf8){
                length_ = 5;
                return true;
            }

            if((c & 0xfe) == 0xfc){
                length_ = 6;
                return true;
            }

            return false;
        }

        bool Is2ndChar(unsigned char c){
            if((c & 0xc0) != 0x80) return false;
            if(position_ != 1) return true;

            auto b = chars_[0];

            switch(length_){
            case 2 : return 0 !=  (b & 0x1e);
            case 3 : return 0 != ((b & 0x0f)|(c & 0x20));
            case 4 : return 0 != ((b & 0x07)|(c & 0x30));
            case 5 : return 0 != ((b & 0x03)|(c & 0x38));
            default: return 0 != ((b & 0x01)|(c & 0x3c));
            }
        }

        void OnError(unsigned char c){
            auto errorChars = position_;
            if(c & 0x80){
                ++errorChars;
            }
            Counter::CountUpErrors(errorChars);
        }

        unsigned char chars_[6];
        unsigned char length_;
        unsigned char position_;
    };

} // namespace my
#endif //_23329405_8a1c_482b_be8e_b99fd3402465
