#ifndef  _d655ba40_f683_4d2f_9479_9f72dd993e4b
#define  _d655ba40_f683_4d2f_9479_9f72dd993e4b

#include <algorithm>
#include <cmath>
#include <cstddef>

namespace my
{

template <class T>
void NormalizeCounts(T const count[], double out[], std::size_t n)
{
    std::transform(count, count+n, out, [](T c){ return (double)c; });

    double norm2 = std::inner_product(out, out+n, out, (double)0);

    if(norm2 > 0){
        double factor = 1.0/std::sqrt(norm2);
        std::transform(out, out+n, out, [factor](double c){ return c*factor; });
    }
}


template <class T, std::size_t n>
inline void NormalizeCounts(T const (&count)[n], double (&out)[n])
{
    return NormalizeCounts(count, out, n);
}

}
#endif //_d655ba40_f683_4d2f_9479_9f72dd993e4b
